<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-dialog :title="title" :close-on-click-modal="false" draggable width="1200px" height="500px" @close="close"
			append-to-body v-model="visible">
			<el-form :model="inputForm" ref="inputForm" v-loading="loading" :rules="rules"
				:class="method === 'view' ? 'readonly' : ''"
				:disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" label-width="100px"
				@submit.native.prevent>
				<el-row :gutter="26">
					<el-col :span="12">
						<el-form-item label="职称名称" prop="name">
							<el-select size="default" v-model="inputForm.name" placeholder="请选择职称名称"
								style="width: 100%;">
								<el-option v-for="item in $dictUtils.getDictList('professional_certificate')"
									:key="item.value" :label="item.label" :value="item.value">
								</el-option>
							</el-select>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="职称等级" prop="proficiency">
							<el-input v-model="inputForm.proficiency" placeholder="请输入职称等级"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="取得日期" prop="obtainDate">
							<el-date-picker v-model="inputForm.obtainDate" type="date" placeholder="请选择取得日期"
								style="width: 100%;">
							</el-date-picker>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="取得途径" prop="category">
							<el-input v-model="inputForm.category" placeholder="请输入取得途径"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="审批单位" prop="usageTime">
							<el-input v-model="inputForm.usageTime" placeholder="请输入审批单位"></el-input>
						</el-form-item>
					</el-col>
					<el-col :span="24">
						<el-form-item label="附件" prop="certificateAttachment">
							<UpLoadComponent ref="upLoadComponent"></UpLoadComponent>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="close()" icon="el-icon-circle-close">关闭</el-button>
					<el-button v-if="method === 'edit' || method == 'add'" type="primary" icon="el-icon-circle-check"
						@click="doSubmit()">确定</el-button>
				</span>
			</template>
		</el-dialog>
	</div>
</template>

<script>
import UpLoadComponent from '@/views/common/UpLoadComponentCardStyle'
import enrollmentRegistrationService from '@/api/human/enrollment/EnrollmentRegistrationService'
export default {
	props: {
		businessId: {
			type: String,
			default: ''
		},
		formReadOnly: {
			type: Boolean,
			default: false
		},
		status: {
			type: String,
			default: ''
		}
	},
	data() {
		return {
			disabled: false,
			title: '',
			method: '',
			visible: false,
			loading: false,
			inputForm: {
				name: '',
				proficiency: '',
				category: '',
				obtainDate: "",
				usageTime: '',
				files: []
			},
			keyWatch: '',
			rules: {
				name: [
					{ required: true, message: '请输入职称名称', trigger: 'blur' }
				],
				proficiency: [
					{ required: true, message: '请输入职称等级', trigger: 'blur' }
				],
				category: [
					{ required: true, message: '请输入取得途径', trigger: 'blur' }
				],
				obtainDate: [
					{ required: true, message: '请输入取得日期', trigger: 'blur' }
				],
				usageTime: [
					{ required: true, message: '请输入审批单位', trigger: 'blur' }
				],
			},
			fileType: ['jpg', 'jpeg', 'png', 'webp'],

		}
	},
	created() {

	},
	components: {
		UpLoadComponent
	},
	computed: {
		bus: {
			get() {
				return this.businessId
			},
			set(val) {
				this.businessId = val
			}
		},
		name() {
			return this.$store.state.user.name
		},
		userId() {
			return this.$store.state.user.id
		}
	},
	watch: {
		'keyWatch': {
			handler(newVal) {
				if (this.commonJS.isNotEmpty(this.bus)) {
					this.init('', this.bus)
				} else {
					this.$nextTick(() => {
						this.$refs.inputForm.resetFields()
					})
				}
			}
		},
		'loading': {
			handler(newVal) {
				this.$emit('changeLoading', newVal)
			}
		}
	},
	methods: {
		getKeyWatch(keyWatch) {
			this.keyWatch = keyWatch
		},
		init(method, id, reId) {
			this.method = method
			this.inputForm = {
				name: '',
				proficiency: '',
				category: '',
				obtainDate: "",
				usageTime: '',
				files: []
			}
			if (method === 'add') {
				this.title = `新增职称证书`
			} else if (method === 'edit') {
				this.title = '修改职称证书'
			} else if (method === 'view') {
				this.title = '查看职称证书'
			}
			this.inputForm.id = id
			this.inputForm.userId = reId
			this.visible = true
			this.loading = true
			this.$nextTick(() => {
				if (id) {
					enrollmentRegistrationService.findSkillInfoById({
						id: this.inputForm.id
					}).then(res => {
						this.inputForm = this.recover(this.inputForm, res)
						this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
						if (!this.inputForm.files) {
							this.inputForm.files = []
						}
						this.$refs.upLoadComponent.newUpload(method, this.inputForm.files, 'skill', 50, null, null, null, null)
						this.loading = false
					})
				} else {
					this.inputForm.id = id
					this.$refs.upLoadComponent.newUpload(method, this.inputForm.files, 'skill', 50, null, null, null, null)
					this.loading = false
				}
			})
		},
		// 表单提交
		doSubmit() {
			if (this.$refs.upLoadComponent.checkProgress()) {
				return
			}
			this.$refs['inputForm'].validate((valid) => {
				if (valid) {
					this.inputForm.obtainDate = new Date(this.inputForm.obtainDate).getTime(); // 转为时间戳
					this.inputForm.files = this.$refs.upLoadComponent.getDataList()
					this.inputForm.status = "5"
					enrollmentRegistrationService.saveSkillInfo(this.inputForm).then(res => {
						this.close()
						this.$message.success(res)
						this.$emit("addSkillInfo", this.inputForm.enrollmentRegistrationId)
						this.loading = false
					})
				}
			})
		},
		close() {
			this.$refs.upLoadComponent.clearUpload()
			this.$refs.inputForm.resetFields()
			this.visible = false
		},
	}
}
</script>


<style lang="less">
.fileUpload {
	.el-form-item__content {
		width: 100%;
	}
}
</style>
